const g_reminderFoxBundle = document.getElementById("reminderFox-bundle");  

const REPEAT_LABEL_NONE =    g_reminderFoxBundle.getString("rf.add.columns.repeat.none");
const REPEAT_LABEL_YEARLY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.yearly");
const REPEAT_LABEL_YEARLY_DAY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.yearlyDay");
const REPEAT_LABEL_MONTHLY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.monthly");
const REPEAT_LABEL_MONTHLY_DAY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.monthlyDay");
const REPEAT_LABEL_WEEKLY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.weekly");
const REPEAT_LABEL_WEEKLY_ALTERNATING =    g_reminderFoxBundle.getString("rf.add.columns.repeat.weekly.atlernating");

const REMINDER_FOX_TIME_ALL_DAY_LABEL = g_reminderFoxBundle.getString("rf.add.time.allday");

const REMINDER_FOX_AM =    g_reminderFoxBundle.getString("rf.add.time.AM");
const REMINDER_FOX_PM =    g_reminderFoxBundle.getString("rf.add.time.PM");
const REMINDER_FOX_TIME_DELIMITER=g_reminderFoxBundle.getString( "rf.add.time.delimiter");


// constants
const COMPLETED_LABEL = "[x]";
const SHOW_IN_TOOLTIP_LABEL = "[x]"  
const REMINDER_ID_REF = "idRef";

var g_modified = false;

var	selectCalendarSync = false;
var calendarReminderArray = new Array(12);

var lastSearchString = null;


function selectTab() {
	// give focus to the reminder/todo description when switching tabs
	var remindersTab = document.getElementById("remindersTab");
	if ( remindersTab.selected ) {
		selectNewReminderText();
	}
	else {
		var todosTab = document.getElementById("todosTab");
		if ( todosTab.selected ) {
			var desc = document.getElementById("addTodoButton");
	    	desc.focus();	    	
	    }
	}
	
}

function reminderFox_enableAddTodoButton(event) {
		var newbutton= document.getElementById("newTodoButton");
		newbutton.removeAttribute( "disabled");
}
	
function loadReminders() {
	fillList(true, true);
	
	// select appropriate tab
	var currentTab = window.arguments[0];
	if ( currentTab == "todos" ) {
		var todosTab = document.getElementById("todosTab");
		var tabbox = document.getElementById("tabbox");
		tabbox.selectedTab = todosTab;		
	}
	
   	var todaysDate = new Date();
	oeDatePicker.onpopupshowing(todaysDate);
	selectCalendarSync = true;
	
	// show calendar based on button state
	var calendar = document.getElementById("oe-date-picker-overlay-box");
	var calendarToggleButton= document.getElementById("calendarToggle");
	if ( calendarToggleButton.checked ) {
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.hide"));	   
		calendar.setAttribute("hidden", "false");	
	}
	else {
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.show"));	   
		calendar.setAttribute("hidden", "true");	
	}
}


function repopulateListForYear(oldYear, newYear) {
	selectCalendarSync = false;
 	// remove all of the calendar items and re-add them
	removeAllListItems( true, false);	  
	fillList(true, false);	
	selectCalendarSync = true;
}

function fillList(  fillReminders,  fillTodoList) {
	var i;
	//var startTime = new Date().getTime();
	if ( fillReminders ) {
		createCalendarReminderArray();
		
		var monthArray, dayReminderArray;
		var monthIndex, dayIndex, reminderIndex;
		for ( monthIndex = 0; monthIndex < 12; monthIndex++ ) {
			monthArray = calendarReminderArray[monthIndex];
			if ( monthArray != null ) {
				for ( dayIndex = 0; dayIndex < 31; dayIndex++ ) {
					dayReminderArray = monthArray[dayIndex];
					if ( dayReminderArray != null ) {
						for ( reminderIndex = 0; reminderIndex < dayReminderArray.length; reminderIndex++ ) {
							createListItemSorted(dayReminderArray[reminderIndex]);
						}
					}
				}
			}
		}
	
//		var endTime = new Date().getTime();
//		var total = endTime - startTime;
//		
//		dump( "Total fill2:  " + total + "\n" );  // 1232
		
		// now that we've added the sorted reminders in the list, let's
		// select (highlight) today's reminder or the next upcoming reminder
		highlightClosestUpcomingReminder( new Date());		
	}
	
	if ( fillTodoList ) {
		var todos = reminderFox_getReminderTodos();
		 for( i = 0; i < todos.length; i++) {
			createTodoListItem(todos[i], false);
		}
		highlightTodo();
	}
		
   	selectNewReminderText();
}

function doFindNext() {
	// only bring up find dialog if reminders tab is selected
	var remindersTab = document.getElementById("remindersTab");
	if ( !remindersTab.selected ) {
		return;
	}
	
	if ( lastSearchString == null ) {
		doFind();
	}
	else {
		findReminder();
	}
}

function doFind() {
	// only bring up find dialog if reminders tab is selected
	var remindersTab = document.getElementById("remindersTab");
	if ( !remindersTab.selected ) {
		return;
	}

	var nsIPromptService = Components.interfaces.nsIPromptService;
	var nsPrompt_CONTRACTID = "@mozilla.org/embedcomp/prompt-service;1";
	var gPromptService = Components.classes[nsPrompt_CONTRACTID].getService(nsIPromptService);
	var result = { value: lastSearchString };
	var dummy = { value: 0 };
	if (gPromptService.prompt(window,
                            g_reminderFoxBundle.getString("rf.add.find.title"),
                            g_reminderFoxBundle.getString("rf.add.find.description"),
                            result,
                            null,
                            dummy)) {
                            
            lastSearchString = result.value;
          
        	findReminder();             
    }    
}

function findReminder( ) {
	var i;
	var item;
	var row;
	var descCell;
	var descCellLabel;
	
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	// if nothing selected, default to start of list
	if ( selectedTreeItemIndex == -1 ) {
		selectedTreeItemIndex = 0;
	}
		
	var treeChildren = document.getElementById("treechildren");
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
	var descLabel = selectedTreeItem.childNodes[0].childNodes[1].getAttribute("label");
   caseInsensitiveLastSearchString = lastSearchString.toUpperCase();

	var treeitems = treeChildren.childNodes;
	var startIndex = selectedTreeItemIndex;
	if ( startIndex + 1 < treeitems.length ) {
		startIndex = startIndex + 1;
	}
	else { 
		startIndex = 0;
	}

	var foundIndex = -1;
	for ( i=startIndex; i < treeitems.length; i++) {
		item = treeitems[i];
		row = item.childNodes[0];
		descCell = row.childNodes[1];
		descCellLabel = descCell.getAttribute("label");
		descCellLabel = descCellLabel.toUpperCase();

		if ( descCellLabel.indexOf( caseInsensitiveLastSearchString ) != -1  ) {
			foundIndex = i;

			break;
		}
	}
	
	if ( foundIndex == -1 ) {
		for ( i=0; i < startIndex; i++) {
			item = treeitems[i];
			 row = item.childNodes[0];
			descCell = row.childNodes[1];
			descCellLabel = descCell.getAttribute("label");
			descCellLabel = descCellLabel.toUpperCase();

			if ( descCellLabel.indexOf( caseInsensitiveLastSearchString ) != -1  ) {
				foundIndex = i;
				break;
			}
		}
	}
	
	// if we found a search match, then highlight the new reminder in the list
	if ( foundIndex != -1 ) {		
		var treeSelection = document.getElementById("reminderTree").view.selection		
		treeSelection.select(foundIndex);
		
		// make sure that newly selected row is shown in scroll pane
		var value = document.getElementById("treeparent").value;
	  	var tree = document.getElementById("reminderTree");			
		var boxobject = tree.boxObject;
		boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
		
		// make sure it shows up at the top if possible
		var first = boxobject.getFirstVisibleRow();
		var last = boxobject.getLastVisibleRow();
		if ( foundIndex < first || foundIndex > last ) {				
			boxobject.scrollToRow(treeitems.length - 9);
		}
		
		var previousReminderOffset = 3;
		if ( foundIndex < previousReminderOffset ) { 
			boxobject.ensureRowIsVisible(i);
		}
		else {
			boxobject.ensureRowIsVisible(foundIndex  - previousReminderOffset);
		}
	}
}


function selectNewReminderText() {
   var desc = document.getElementById("addReminderButton");  
    desc.focus();
}



function toggleCalendar() {
	var calendar = document.getElementById("oe-date-picker-overlay-box");
	var calendarToggleButton= document.getElementById("calendarToggle");
	if ( calendarToggleButton.checked ) {
		calendar.setAttribute("hidden", "true");	
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.show"));	
	}
	else {
		calendar.setAttribute("hidden", "false");	
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.hide"));	
	}
}

function reminderSelected(event) {
	if ( selectCalendarSync ) {
		var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
		if ( selectedTreeItemIndex >= 0 ) {
			var treeChildren = document.getElementById("treechildren");
			if ( treeChildren != null ) {
				if ( selectedTreeItemIndex >= treeChildren.childNodes.length ) {
					selectedTreeItemIndex = treeChildren.childNodes.length - 1;
				}
				var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
				var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
				var dateLabelArray = dateLabel.split(" ");
				var monthAsInteger = reminderFox_getMonthAsInteger(dateLabelArray[0]);		
				var day = dateLabelArray[1];
				var year = oeDatePicker.gSelectedDate.getFullYear();
				if ( year == null ) {
					year = new Date().getFullYear();
				}
				var newDate = new Date(year, monthAsInteger, day );	
				oeDatePicker.onpopupshowing(newDate);
			}
		}
	}
}

function doShowHTML() {
	var win1 = window.open('', 'ReminderFoxHTML');
	win1.document.open();
	win1.document.title =  g_reminderFoxBundle.getString("rf.title");
	win1.document.write("<basefont  color=\"#FFFFFF\">\n");
	win1.document.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 // Transitional//EN\">\n");
	
	win1.document.write("<HTML>\n");
	win1.document.write("<HEAD>\n");
	win1.document.write("<TITLE>" + g_reminderFoxBundle.getString("rf.title") + "</TITLE>\n");
	win1.document.write("</HEAD>\n");
	win1.document.write("<BODY>\n");
	
	win1.document.write("<TABLE border=\"1\">\n");
	win1.document.write(" <TBODY>\n");	
	
	win1.document.write( "  <TR>\n");
	
	win1.document.write( "    <TD>\n");
	win1.document.write( "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.date") + "</b>\n");
	win1.document.write( "    </TD>\n");
	
	win1.document.write( "    <TD>\n");
	win1.document.write( "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.reminder") + "</b>\n");
	win1.document.write( "    </TD>\n");
	
	win1.document.write( "  </TR>\n");		
	
	var i;
	var item;
	var row;
	var dateCell;
	var dateCellLabel	
	var descCell;
	var descCellLabel;
		
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;

	for ( i=0; i < treeitems.length; i++) {
		item = treeitems[i];
		row = item.childNodes[0];
		dateCell = row.childNodes[0];
		dateCellLabel = dateCell.getAttribute("label");
		descCell = row.childNodes[1];
		descCellLabel = descCell.getAttribute("label");
		
		win1.document.write( "  <TR>\n");

		win1.document.write( "    <TD>\n");
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    <FONT color=\"FF0000\">\n");
		}	
		win1.document.write( "      " );
		win1.document.write(dateCellLabel + "\n");
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    </FONT>\n");
		}				
		win1.document.write( "    </TD>\n");
		
		win1.document.write( "    <TD>\n");
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    <FONT color=\"FF0000\">\n");
		}	
		win1.document.write( "      " );
		win1.document.write( descCellLabel + '\n');
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    </FONT>\n");
		}				
		win1.document.write( "    </TD>\n");		

		
		win1.document.write( "  </TR>\n");	
	}	
	
	win1.document.write( " </TBODY>\n");
	win1.document.write( "</TABLE>\n");
	win1.document.write( "</BODY>\n");
	win1.document.write( "</HTML>\n");

	win1.document.close();
}


function doShowToDosHTML() {
	var win1 = window.open('', 'ReminderFoxHTML');
	win1.document.open();
	win1.document.title =  g_reminderFoxBundle.getString("rf.title");
	win1.document.write("<basefont  color=\"#FFFFFF\">\n");		
	win1.document.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 // Transitional//EN\">\n");

	win1.document.write("<HTML>\n");
	win1.document.write("<HEAD>\n");
	win1.document.write("<TITLE>" +g_reminderFoxBundle.getString("rf.title") + "</TITLE>\n");
	win1.document.write("</HEAD>\n");
	win1.document.write("<BODY>\n");
	win1.document.write("<TABLE border=\"1\">\n");
	win1.document.write(" <TBODY>\n");	
	
	win1.document.write( "  <TR>\n");
	
	win1.document.write( "    <TD>\n");		
	win1.document.write( "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.todo.number") + "</b>\n");
	win1.document.write( "    </TD>\n");
	
	win1.document.write( "    <TD>\n");	
	win1.document.write( "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.todo") + "</b>\n");
	win1.document.write( "    </TD>\n");
	
	win1.document.write( "  </TR>\n");		

	var i;
	var item;
	var row;
	var descCell;
	var descCellLabel;
		
	var treeChildren = document.getElementById("todoTreechildren");
	var treeitems = treeChildren.childNodes;

	for ( i=0; i < treeitems.length; i++) {
		item = treeitems[i];
		row = item.childNodes[0];
		descCell = row.childNodes[0];
		descCellLabel = descCell.getAttribute("label");
		
		win1.document.write( "  <TR>\n");
		
		win1.document.write( "    <TD>\n");
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    <FONT color=\"FF0000\">\n");
		}			
		win1.document.write( "      ");		
		win1.document.write(i + "\n");
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    </FONT>\n");
		}			
		win1.document.write( "    </TD>\n");
		
		win1.document.write( "    <TD>\n");
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    <FONT color=\"FF0000\">\n");
		}			
		win1.document.write( "      " );
		win1.document.write( descCellLabel + '\n');
		if ( descCell.getAttribute("properties" ) == "important" ) {
			win1.document.write( "    </FONT>\n");
		}			
		win1.document.write( "    </TD>\n");		
		
		win1.document.write( "  </TR>\n");	
	}	
	
	win1.document.write( " </TBODY>\n");
	win1.document.write( "</TABLE>\n");
	win1.document.write( "</BODY>\n");
	win1.document.write( "</HTML>\n");

	win1.document.close();
}


function createCalendarReminderArray() {
	var monthArray;
	var monthDay;	
	var dayReminderArray;	
	var newDayReminder;
	var  length;
	var val;
		
	calendarReminderArray = new Array(12); 
	
	var reminders = reminderFox_getReminderEvents();	
	var currentDate = oeDatePicker.gSelectedDate;
	if ( currentDate == null ) {
		currentDate = new Date();
	}
	var	year = currentDate.getFullYear();

	var currentDate = new Date( year, 0, 1 );  // start of year
	var endDate  = new Date( year, 11, 31 );  // end of year	
	
	for( var i = 0; i < reminders.length; i++) {
		var basereminder = reminders[i];
		
		var allReminders = reminderFox_getAllRemindersInDateRange( basereminder,  currentDate, endDate, false );
		for (  var j = 0; j < allReminders.length; j++ ) {		
			var reminder = allReminders[j];		

			reminder = reminderFox_processReminderDescription(reminder, currentDate.getFullYear());	
			// if it's marked as RemindUntilComplete, this should be treated as Today's date			
		 	if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED && j == 0 ) {
		 		var todaysDate = new Date();
		 		if (  todaysDate.getFullYear() == year ) {   // only valid for current year in the calendar
						reminder.date  = new Date( todaysDate.getFullYear(), todaysDate.getMonth(), todaysDate.getDate(), 
					 			reminder.date.getHours(), reminder.date.getMinutes() );		 
				}		 								
		 	}		 	
	
			monthArray = calendarReminderArray[reminder.date.getMonth()];
			if ( monthArray == null ) {
				monthArray = new Array(31);
				calendarReminderArray[reminder.date.getMonth()] = monthArray;
			}
				
			monthDay = reminder.date.getDate();
			dayReminderArray = monthArray[monthDay - 1];
			if ( dayReminderArray == null ) {
				dayReminderArray = new Array();
				monthArray[monthDay - 1] = dayReminderArray;
			}
			length = dayReminderArray.length;
			dayReminderArray[length] = reminder;
		}
	}
}


function reminderFox_getAddTimeString( reminder ) {
	var timeString = null;
	if ( !reminder.allDayEvent ) {
		try {
			var hours = reminder.date.getHours();
			var AMorPM = REMINDER_FOX_PM;
			if ( AMorPM != "" ) {
				if ( hours < 12 ) {
					AMorPM = REMINDER_FOX_AM;
				}
				if ( hours == 0 ) {
					hours = 12;
				}
				if ( hours >= 13 ) {
					hours = hours -12;
				}	
			}			

			var minutes = reminder.date.getMinutes();
			if ( minutes < 10 ) {
				minutes = "0" + minutes;
			}
							
			timeString = hours + REMINDER_FOX_TIME_DELIMITER + minutes;
			if ( AMorPM != "" ) {
				timeString = timeString + " " + AMorPM;		
			}
		}
		catch ( e ) { 
		}
	}	
	return timeString;
}

function createListItem(baseReminder) {
	var lastListIndex = 0;
	var once = document.getElementById("occurrence");
	var treeChildren = document.getElementById("treechildren");
	var year;
	if ( oeDatePicker.gSelectedDate != null ) {
		year = oeDatePicker.gSelectedDate.getFullYear();
	}
	if ( year == null ) {
		year = new Date().getFullYear();
	}	 
	var currentDate = new Date( year, 0, 1 );  // start of year
	var endDate  = new Date( year, 11, 31 );  // end of year

	var allReminders = reminderFox_getAllRemindersInDateRange( baseReminder,  currentDate, endDate, false );

	for (  var j = 0; j < allReminders.length; j++ ) {
		var treeSelection;
		var value ;
		var tree;	
		var boxobject;
		var first;
		var last;
		var previousReminderOffset ;		

		var newItem = document.createElement("treeitem");
		var newRow = document.createElement("treerow");
		newRow.setAttribute( REMINDER_ID_REF, baseReminder.id );
		var newDateLabel = document.createElement("treecell");
		var newDescLabel = document.createElement("treecell");
		
		newItem.appendChild(newRow);
		newRow.appendChild(newDateLabel);
		newRow.appendChild(newDescLabel);
		var isImportant = false;	
		
		var reminder = allReminders[j];		
		reminder = reminderFox_processReminderDescription(reminder, year);		
		
		// if it's marked as RemindUntilComplete, this should be treated as Today's date
	 	if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED && j == 0 ) {
	 		var todaysDate = new Date();
	 		if (  todaysDate.getFullYear() == year ) {   // only valid for current year in the calendar
				reminder.date  = new Date( todaysDate.getFullYear(), todaysDate.getMonth(), todaysDate.getDate(), 
					 			reminder.date.getHours(), reminder.date.getMinutes() );	
			}
	 	}
	
		var dayVal = reminder.date.getDate();
		var monthArray = calendarReminderArray[reminder.date.getMonth()];
		if ( monthArray == null ) {
			monthArray = new Array(31);
			calendarReminderArray[reminder.date.getMonth()] = monthArray;
		}

	
		var dayReminderArray = monthArray[dayVal - 1];
		if ( dayReminderArray == null ) {
			dayReminderArray = new Array();
			monthArray[dayVal - 1] = dayReminderArray;
		}

		var  length = dayReminderArray.length;
		dayReminderArray[length] = reminder;

		var monthAsText = reminderFox_getMonthAsText(reminder.date.getMonth());		
		newDateLabel.setAttribute("label", monthAsText + " " + dayVal);
		newDescLabel.setAttribute("label", reminder.summary);
				
		var newTimeLabel = document.createElement("treecell");
		newRow.appendChild(newTimeLabel);		
		
		var newRepeatLabel = document.createElement("treecell");
		newRow.appendChild(newRepeatLabel);
		
		var newCompleteLabel = document.createElement("treecell");
		newRow.appendChild(newCompleteLabel);
		
		var newRemindUntilCompletedLabel = document.createElement("treecell");
		newRow.appendChild(newRemindUntilCompletedLabel);
	
		if ( reminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
             // mark the date and description as important (red-highlighted)
            newDateLabel.setAttribute("properties", "important");
            newDescLabel.setAttribute("properties", "important");
            newTimeLabel.setAttribute("properties", "important");
            isImportant = true;
         }
         if ( reminder.complete ) {
        	 newCompleteLabel.setAttribute("label", COMPLETED_LABEL);		 // only if date is first date greater than or equal to today
         }
         if ( reminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
         	newRemindUntilCompletedLabel.setAttribute("label", COMPLETED_LABEL);			  // only if first date after today 
         }

		if ( reminder.allDayEvent ) {
			newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {
			var time = reminderFox_getAddTimeString(reminder);
			if ( time == null ) {
				newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
			}
			else {			
				newTimeLabel.setAttribute("label", time);
			}
		}
		
		if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY_DAY);
		}		
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY_DAY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY_ALTERNATING);
		}		
		else {		
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_NONE);
		}		

		// Figure out where to put the new item in sorted list
		var treeitems = treeChildren.childNodes;
		var added = false;
		
		for (var i=lastListIndex; i < treeitems.length; i++) {
			var item = treeitems[i];
			var row = item.childNodes[0];
			var dateCell = row.childNodes[0];
			var dateLabel = dateCell.getAttribute("label");
			var dateLabelDiv = dateLabel.split(" ");
			var month = reminderFox_getMonthAsInteger(dateLabelDiv[0]);
			var date = dateLabelDiv[1];
			
			if (month > reminder.date.getMonth() || (month == reminder.date.getMonth() && dayVal <= date ) ) {	
				if (month == reminder.date.getMonth() && date == dayVal) {
					if ( !isImportant ) {
						// if this reminder is not marked as important, add to the 
						// end of the list of today's reminders
						continue;
					}
				}
				treeChildren.insertBefore(newItem, item);
				added = true;
			
				// highlight the newly added reminder in the list
				treeSelection = document.getElementById("reminderTree").view.selection;	
				if ( selectCalendarSync ) {
						treeSelection.select(i);
						// make sure that newly selected row is shown in scroll pane
						value = document.getElementById("treeparent").value;
						tree = document.getElementById("reminderTree");					
						boxobject = tree.boxObject;
						boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
						
						first = boxobject.getFirstVisibleRow();
						last = boxobject.getLastVisibleRow();
						if ( i < first || i > last ) {	
							boxobject.scrollToRow(treeitems.length - 1);
							boxobject.scrollToRow(treeitems.length - 9);
						}
											
						previousReminderOffset = 3;
						if ( i < previousReminderOffset ) { 
							boxobject.ensureRowIsVisible(i);
						}
						else {
							boxobject.ensureRowIsVisible(i  - previousReminderOffset);
						}						
				}
				lastListIndex = i;
				break;
			}
		}
			
		if (!added){		
			treeChildren.appendChild(newItem);
			// highlight the newly added reminder in the list
			treeSelection = document.getElementById("reminderTree").view.selection;	
			if ( selectCalendarSync ) {
				treeSelection.select(treeitems.length - 1);
				// make sure that newly selected row is shown in scroll pane
				value = document.getElementById("treeparent").value;
				tree = document.getElementById("reminderTree");					
				boxobject = tree.boxObject;
				boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
				
				first = boxobject.getFirstVisibleRow();
				last = boxobject.getLastVisibleRow();
				if ( i < first || i > last ) {	
					boxobject.scrollToRow(treeitems.length - 1);			
					boxobject.scrollToRow(treeitems.length - 9);
				}
				
				previousReminderOffset = 3;
				if ( i < previousReminderOffset ) { 
					boxobject.ensureRowIsVisible(i);
				}
				else {
					boxobject.ensureRowIsVisible(i  - previousReminderOffset);
				}					
			}		
		}
	}
}


function createListItemSorted(reminder) {
	var lastListIndex = 0;
	var once = document.getElementById("occurrence");
	var treeChildren = document.getElementById("treechildren");

	var newItem = document.createElement("treeitem");
	var newRow = document.createElement("treerow");
	newRow.setAttribute( REMINDER_ID_REF, reminder.id );
	var newDateLabel = document.createElement("treecell");
	var newDescLabel = document.createElement("treecell");
	
	newItem.appendChild(newRow);
	newRow.appendChild(newDateLabel);
	newRow.appendChild(newDescLabel);
	var isImportant = false;	
	
	var monthAsText = reminderFox_getMonthAsText(reminder.date.getMonth());		
	newDateLabel.setAttribute("label", monthAsText + " " +  reminder.date.getDate());
	newDescLabel.setAttribute("label", reminder.summary);
			
	var newTimeLabel = document.createElement("treecell");
	newRow.appendChild(newTimeLabel);		
	
	var newRepeatLabel = document.createElement("treecell");
	newRow.appendChild(newRepeatLabel);
	
	var newCompleteLabel = document.createElement("treecell");
	newRow.appendChild(newCompleteLabel);
	
	var newRemindUntilCompletedLabel = document.createElement("treecell");
	newRow.appendChild(newRemindUntilCompletedLabel);

	if ( reminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
         // mark the date and description as important (red-highlighted)
        newDateLabel.setAttribute("properties", "important");
        newDescLabel.setAttribute("properties", "important");
        newTimeLabel.setAttribute("properties", "important");
        isImportant = true;
     }
     if ( reminder.complete ) {
    	 newCompleteLabel.setAttribute("label", COMPLETED_LABEL);		 // only if date is first date greater than or equal to today
     }
     if ( reminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
     	newRemindUntilCompletedLabel.setAttribute("label", COMPLETED_LABEL);			  // only if first date after today 
     }

	if ( reminder.allDayEvent ) {
		newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
	}
	else {
		var time = reminderFox_getAddTimeString(reminder);
		if ( time == null ) {
			newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {			
			newTimeLabel.setAttribute("label", time);
		}
	}
	
	if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY);
	}
	else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY_DAY);
	}		
	else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY);
	}
	else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY_DAY);
	}
	else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY);
	}
	else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY_ALTERNATING);
	}		
	else {		
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_NONE);
	}		

	treeChildren.appendChild(newItem);	
}


function createTodoListItem(todo, sort) {
	var tree ;
	var treeSelection
	var boxobject;
	var item;	
	
	var treeChildren = document.getElementById("todoTreechildren");
	var newItem = document.createElement("treeitem");
	var newRow = document.createElement("treerow");
	newRow.setAttribute( REMINDER_ID_REF, todo.id );	
	var newDescLabel = document.createElement("treecell");
	
	newItem.appendChild(newRow);
	newRow.appendChild(newDescLabel);
	var isImportant = false;
	
	newDescLabel.setAttribute("label", todo.summary);
		
	var newCompletedLabel = document.createElement("treecell");
	newRow.appendChild(newCompletedLabel);
	
	// check for any options that are specified, and mark them in the columns 
	if ( todo.priority == REMINDER_PRIORITY_IMPORTANT) { 
            newDescLabel.setAttribute("properties", "important");
            isImportant = true;
     }
     if ( todo.showInTooltip ) {
            newCompletedLabel.setAttribute("label", SHOW_IN_TOOLTIP_LABEL);		
     }	
    
	var treeitems = treeChildren.childNodes;
	if( !sort || treeitems.length == 0 ) {
        treeChildren.appendChild(newItem);
        if ( treeitems.length == 1 ) {
            var treeSelection = document.getElementById("todoTree").view.selection;	
			treeSelection.select(0);
        }
	}
    // if current todo is not important, add after important items
    else if ( !isImportant) {
		var added = false;
		for (var i=0; i < treeitems.length && !added; i++) {
			item = treeitems[i];
			var row = item.childNodes[0];
			var todoRefId = row.getAttribute(REMINDER_ID_REF);			
			var todoAtIndex = reminderFox_getTodosById( todoRefId );				
			var descCell = row.childNodes[0];
			var descLabel = descCell.getAttribute("label");		
			
 			if ( !todoAtIndex.priority == REMINDER_PRIORITY_IMPORTANT ) {
	        	if (  todo.showInTooltip ) {
	     			treeChildren.insertBefore(newItem, item);
					added = true;	        	
					// highlight the newly added reminder in the list
					tree = document.getElementById("todoTree");	
					treeSelection = tree.view.selection;	
					treeSelection.select(i);					
	
					boxobject = tree.boxObject;
					boxobject.ensureRowIsVisible(i);
				}
	        	else {
	        		if ( !todoAtIndex.showInTooltip  ) {
						treeChildren.insertBefore(newItem, item);
						added = true;
						// highlight the newly added reminder in the list
						tree = document.getElementById("todoTree");	
						treeSelection = tree.view.selection;	
						treeSelection.select(i);
						
						boxobject = tree.boxObject;
						boxobject.ensureRowIsVisible(i);
	        		}
	        	}
	        
	        }
		}
		
    
    	if ( !added ) {
           	treeChildren.appendChild(newItem);
			// highlight the newly added reminder in the list 	 
	    	tree = document.getElementById("todoTree");	
	    	treeSelection = tree.view.selection;	
			treeSelection.select(treeitems.length - 1);			
							
			boxobject = tree.boxObject;
			boxobject.ensureRowIsVisible(treeitems.length - 1);
       }
    }
    // new Todo is important - add to top of list
    else {        	
    	item = treeitems[0];
    	treeChildren.insertBefore(newItem, item);
		added = true;
		
		// highlight the newly added reminder in the list
		tree = document.getElementById("todoTree");	
		treeSelection = tree.view.selection;	
		treeSelection.select(0);
						
		boxobject = tree.boxObject;
		boxobject.ensureRowIsVisible(0);
    }	
	
}


function createTodoListItemAtIndex(todo, index) {
	var tree ;
	var treeSelection
	var boxobject;
	var item;	
	
	var treeChildren = document.getElementById("todoTreechildren");
	var newItem = document.createElement("treeitem");
	var newRow = document.createElement("treerow");
	newRow.setAttribute( REMINDER_ID_REF, todo.id );	
	var newDescLabel = document.createElement("treecell");
	
	newItem.appendChild(newRow);
	newRow.appendChild(newDescLabel);
	var isImportant = false;
	
	newDescLabel.setAttribute("label", todo.summary);
		
	var newCompletedLabel = document.createElement("treecell");
	newRow.appendChild(newCompletedLabel);
	
	// check for any options that are specified, and mark them in the columns 
	if ( todo.priority == REMINDER_PRIORITY_IMPORTANT) { 
            newDescLabel.setAttribute("properties", "important");
            isImportant = true;
     }
     if ( todo.showInTooltip ) {
            newCompletedLabel.setAttribute("label", SHOW_IN_TOOLTIP_LABEL);		
     }	
    
	var treeitems = treeChildren.childNodes;	
	// insert at end if last item
	if ( index >= treeitems.length ) {
        treeChildren.appendChild(newItem);
        // highlight the newly added reminder in the list 	 
        tree = document.getElementById("todoTree");	
        treeSelection = tree.view.selection;	
        treeSelection.select(treeitems.length -1 );			
                        
        boxobject = tree.boxObject;
        boxobject.ensureRowIsVisible(treeitems.length -1 );	
	
	}
	else {
		// otherwise insert before current item at index
		item = treeitems[index ];
		treeChildren.insertBefore(newItem, item);
		
		tree = document.getElementById("todoTree");	
		treeSelection = tree.view.selection;	
		treeSelection.select(index);					
	
		boxobject = tree.boxObject;
		boxobject.ensureRowIsVisible(index);	
	}
}


/**
  * select (highlight) today's reminder or the next upcoming reminder
  */
function highlightClosestUpcomingReminder(currentDate) {
	var currentMonth = currentDate.getMonth();
	var currentDay = currentDate.getDate();
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var dateCell = row.childNodes[0];
		var dateLabel = dateCell.getAttribute("label");
		var dateLabelDiv = dateLabel.split(" ");
		var month = reminderFox_getMonthAsInteger(dateLabelDiv[0]);
		var date = parseInt(dateLabelDiv[1]);
		if ( month > currentMonth || (month == currentMonth && date >= currentDay ) ) {
			var treeSelection = document.getElementById("reminderTree").view.selection		
			treeSelection.select(i);
			
			// make sure that newly selected row is shown in scroll pane
			var value = document.getElementById("treeparent").value;
		  	var tree = document.getElementById("reminderTree");			
			var boxobject = tree.boxObject;
			boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
			
			// make sure it shows up at the top if possible
			var first = boxobject.getFirstVisibleRow();
			var last = boxobject.getLastVisibleRow();
			if ( i < first || i > last ) {				
				boxobject.scrollToRow(treeitems.length - 9);
			}
			
			var previousReminderOffset = 3;
			if ( i < previousReminderOffset ) { 
				boxobject.ensureRowIsVisible(i);
			}
			else {
				boxobject.ensureRowIsVisible(i  - previousReminderOffset);
			}
			break;
		}
	}
}

/**
  * select (highlight) today's reminder or the next upcoming reminder
  */
function highlightReminderForDate(currentMonth, currentDay) {
	var highlighted = false;
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var dateCell = row.childNodes[0];
		var dateLabel = dateCell.getAttribute("label");
		var dateLabelDiv = dateLabel.split(" ");
		var month = reminderFox_getMonthAsInteger(dateLabelDiv[0]);
		var date = parseInt(dateLabelDiv[1]);
		if ( month == currentMonth && date == currentDay ) {
			highlighted = true;
			var treeSelection = document.getElementById("reminderTree").view.selection		
			treeSelection.select(i);

			// make sure that newly selected row is shown in scroll pane
			var value = document.getElementById("treeparent").value;
		  	var tree = document.getElementById("reminderTree");			
			var boxobject = tree.boxObject;
			boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
			
			// make sure it shows up at the top if possible
			var first = boxobject.getFirstVisibleRow();
			var last = boxobject.getLastVisibleRow();
			
			if ( i <= first || i >= last ) {				
				boxobject.scrollToRow(treeitems.length - 9);
			}
			
			var previousReminderOffset = 3;
			if ( i < previousReminderOffset ) { 
				boxobject.ensureRowIsVisible(i);
			}
			else {
				boxobject.ensureRowIsVisible(i  - previousReminderOffset);
			}
			break;
		}
	}
	
	if ( !highlighted ) {
		selectNewReminderText();
	}
}

function highlightTodo() {
	var tree = document.getElementById("todoTree");			
	var treeSelection = tree.view.selection;	
	treeSelection.select(0);	
	treeSelection.clearSelection();
			
	var boxobject = tree.boxObject;
	boxobject.ensureRowIsVisible(0);	
}


function removeListItemsForReminder(reminder) {
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=treeitems.length - 1; i >= 0; i--) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
		if ( reminderRefId == reminder.id ) {			
			treeChildren.removeChild(item);
		}
	}
}

function removeTodoListItem(todo) {
	var treeChildren = document.getElementById("todoTreechildren");
	var treeitems = treeChildren.childNodes;

	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var todoRefId = row.getAttribute(REMINDER_ID_REF);		
		if ( todoRefId == todo.id ) {			
			treeChildren.removeChild(item);
			break;
		}
	}	
}


// saves and closes the 'edit reminders' dialog
function revert() {
	// there were changes.  Prompt user to revert/cancel
	// get a reference to the prompt service component.
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);

	var flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
   	promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1;     
	var msg =  g_reminderFoxBundle.getString("rf.add.revert.description");
	var buttonPressed = promptService.confirmEx(window,g_reminderFoxBundle.getString("rf.add.revert.title"),
	  msg,
	  flags, g_reminderFoxBundle.getString("rf.add.revert.button.revert.title"), g_reminderFoxBundle.getString("rf.button.cancel"), null, null, {});		  
	  
	// revert pressed
	if ( buttonPressed == 0 ) {		
		var revertReminders = true;
		var revertTodos = true;

		reminderFox_clearRemindersAndTodos();
		removeAllListItems(revertReminders, revertTodos);
		fillList(revertReminders, revertTodos);
		refreshCalendar();

		// grey out the revert buttons
		var revertButton= document.getElementById("revertbutton");
		revertButton.setAttribute( "disabled", true );
		
		var revertButtonTodos= document.getElementById("revertbuttonTodos");
		revertButtonTodos.setAttribute( "disabled", true );
		
		g_modified = false;
	}	
}

function removeAllListItems(removeReminders, removeTodos) {
	if ( removeReminders ) {
		var reminderTree = document.getElementById("reminderTree");
		var treeChildren = document.getElementById("treechildren");
		reminderTree.removeChild(treeChildren);
		
		var newchildren = document.createElement("treechildren");
		newchildren.setAttribute("id", "treechildren");
		newchildren.setAttribute("ondblclick", "if (event.button == 0) editReminder()");
		reminderTree.appendChild(newchildren);
	}

	if ( removeTodos ) {
		var todoTreeChildren = document.getElementById("todoTreechildren");
	     while (todoTreeChildren.hasChildNodes()) {
	    	 todoTreeChildren.removeChild(todoTreeChildren.firstChild);
	  	 }		
	 }	
}


// saves and closes the 'edit reminders' dialog
function saveSettings() {
	var currentDate = new Date();
	var day = currentDate.getDate();
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);	
	var windowEnumerator = reminderFox_getWindowEnumerator();
	var currentWindow;
	var daysChanged = false;
	// see if the day has changed since last process
	if (windowEnumerator.hasMoreElements()) {
		currentWindow = windowEnumerator.getNext();		
		if ( currentWindow.reminderFox_lastDay != day ) {
			daysChanged = true;
		}
	}
			
	// if any events were modified or the day has changed, we want to update the tooltip and status text
	if ( g_modified || daysChanged ) {  
		reminderFox_writeOutRemindersAndTodos();
			
		try {
			// update all of the browsers
			windowEnumerator =  reminderFox_getWindowEnumerator();
			while (windowEnumerator.hasMoreElements()) {
				var currentWindow = windowEnumerator.getNext();		
				currentWindow.reminderFoxEvents = reminderFoxEvents;
				currentWindow.reminderFoxTodos  = reminderFoxTodos;
				
				currentWindow.reminderFox_loadReminderFox(true);			
				currentWindow.reminderFox_clearRemindersAndTodos();
			}
		}
		catch(e) {
		}
	}
	
	// clear reminders from memory
	reminderFox_clearRemindersAndTodos();
	
	g_modified = false;
	window.close();
}
function dblClickDay(newDayItemNumber) {
   var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + newDayItemNumber );
   var dayNumber = dayNumberItem.getAttribute( "value" );
   
   // they may have clicked an unfilled day, if so ignore it and leave the picker up   
   if( dayNumber != "" )  {
		addReminder();
   }
}

// Adds the new reminder from the edit reminder dialog
function addReminder() {
	var newDate = oeDatePicker.gSelectedDate;
	if ( newDate == null ) {
		newDate = new Date();
	}	
	var originalYear = newDate.getFullYear();

	var reminderId =reminderFox_generateUniqueReminderId( newDate );
	var	newReminderToBeAdded = new ReminderFoxEvent( reminderId, newDate, "" );

	var newOptions = { reminder: newReminderToBeAdded, editing:  false,  addReminder: false };
	window.openDialog("chrome://reminderfox/content/reminderOptionsDialog.xul",
			"reminderOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addReminder ) {
		// if adding a new reminder in a different year, first set the list/calendar to the new year 
		// before adding the reminder
		if ( originalYear != newReminderToBeAdded.date.getFullYear() ) {
		   	oeDatePicker.gSelectedDate = newReminderToBeAdded.date;
			repopulateListForYear( originalYear, newReminderToBeAdded.date.getFullYear() );
		}
	
		// add reminder in sorted order...
		var reminders = reminderFox_getReminderEvents();	
		var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, newReminderToBeAdded, false );
		reminderFox_insertIntoArray( reminders, newReminderToBeAdded, sortedIndex );
		
		createListItem(newReminderToBeAdded);
		oeDatePicker.onpopupshowing(newReminderToBeAdded.date);
		
		modifiedReminders();
	}
}

function modifiedReminders() {
	g_modified = true;

	var revertButton= document.getElementById("revertbutton");
	revertButton.setAttribute( "disabled", false );
	
	var revertButtonTodos= document.getElementById("revertbuttonTodos");
	revertButtonTodos.setAttribute( "disabled", false );
}

function addTodo() {
	var todoId =reminderFox_generateUniqueTodoId();
	var newTodo = new ReminderFoxTodo(todoId, "" );
	newTodo.showInTooltip = true;

	var newOptions = { todo: newTodo, editing:  false,  addTodo: false };
	window.openDialog("chrome://reminderfox/content/todoOptionsDialog.xul",
			"todoOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addTodo ) {
		// add todo in sorted order...
		var todos = reminderFox_getReminderTodos();		
		var sortedIndex = reminderFox_getSortedIndexOfNewTodo(todos,  newTodo );
		reminderFox_insertIntoArray( todos, newTodo, sortedIndex );
	
		createTodoListItem(newTodo, true);
	
		modifiedReminders();
	}
	
}

function editTodo() {
	var currentTodo = getTodoForSelectedItem( );

	var newOptions = { todo: currentTodo, editing:  true,  addTodo: false };
	window.openDialog("chrome://reminderfox/content/todoOptionsDialog.xul",
			"todoOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addTodo ) {
		var modified = updateTodoInList( currentTodo );
		modifiedReminders();
	}
	
}


function removeReminder() {
	var currentReminder = getReminderForSelectedItem( );

	// remove from UI list
	removeListItemsForReminder(currentReminder);
	
	// remove from model list
	var reminders = reminderFox_getReminderEvents();	
	for( var i = 0; i < reminders.length; i++) {
		if ( reminders[i].id == currentReminder.id ) {
			reminderFox_removeElement(reminders, i);
			break;
		}
	}
}


function removeTodo() {
	var currentTodo = getTodoForSelectedItem();
	if ( currentTodo != null ) {
		// remove from UI list
		removeTodoListItem(currentTodo);
		
		// remove from model list
		var todos = reminderFox_getReminderTodos();
		for( var i = 0; i < todos.length; i++) {
			if ( todos[i].id == currentTodo.id ) {
				reminderFox_removeElement(todos, i);
				break;
			}
		}
	}

}
function activateCalendarContext(event, newDayItemNumber) {
   var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + newDayItemNumber );
   var dayNumber = dayNumberItem.getAttribute( "value" );
   
   // they may have clicked an unfilled day, if so ignore it and leave the picker up   
   if( dayNumber != "" )  {
		var tree = document.getElementById("reminderTree");
		var treeContextMenu = document.getElementById("treechildren-calendar-contextmenu");
	
		document.popupNode = tree;
		var noExistingReminder = false;
	
		// modify context menu depending on Important reminder status
		var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
		if ( selectedTreeItemIndex == -1 ) {
			noExistingReminder = true;
		}
		treeContextMenu.showPopup(tree, event.clientX, event.clientY, "bottomleft", "topleft");
		var currentReminder = getReminderForSelectedItem( );
		if ( currentReminder == null ) {
			noExistingReminder = true;
		}
		// check that it's pointing to the current date; otherwise it means there is no current reminder for this date
		else 	{
				if ( !noExistingReminder ) {
					// check the date from the tree list, as the actual reminder could have an earlier date (if it's
					// set for RemindUntilComplete, for example)
					var treeChildren = document.getElementById("treechildren");
					var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
					var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
					var dateLabelArray = dateLabel.split(" ");	
					var day = dateLabelArray[1];
					if ( day != dayNumber ) {
						noExistingReminder = true;
					}
				}
		}
		
		var contextMenuImportant = document.getElementById("treechildren-calendar-contextmenu-important");	
		var contextMenuRemindComplete = document.getElementById("treechildren-calendar-contextmenu-remindUntilComplete");			
		var contextMenuComplete = document.getElementById("treechildren-calendar-contextmenu-markAsComplete");	
		var contextEdit = document.getElementById("treechildren-calendar-contextmenu-edit");			
		var contextDelete= document.getElementById("treechildren-calendar-contextmenu-delete");			
		var contextMoveToTodos = document.getElementById("treechildren-calendar-contextmenu-moveToTodos");			
		if ( noExistingReminder ) {
			contextEdit.setAttribute( "disabled", true );
			contextDelete.setAttribute( "disabled", true );			
			contextMoveToTodos.setAttribute( "disabled", true );						
			contextMenuImportant.setAttribute( "disabled", true );
			contextMenuRemindComplete.setAttribute( "disabled", true );
			contextMenuComplete.setAttribute( "disabled", true );			

			contextMenuImportant.setAttribute("checked", "false");	
			contextMenuRemindComplete.setAttribute("checked", "false");	 
			contextMenuComplete.setAttribute("checked", "false");					
		}		
		else {
			contextEdit.removeAttribute( "disabled" );
			contextDelete.removeAttribute( "disabled" );
			contextMoveToTodos.removeAttribute( "disabled" );
			contextMenuImportant.removeAttribute( "disabled" );
			contextMenuRemindComplete.removeAttribute( "disabled" );
			contextMenuComplete.removeAttribute( "disabled" );
					
			if ( currentReminder.priority != REMINDER_PRIORITY_IMPORTANT ) {
				contextMenuImportant.setAttribute("checked", "false");	
			}
			else {
				contextMenuImportant.setAttribute("checked", "true");	
			}
			
			if ( currentReminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE) {
				contextMenuRemindComplete.setAttribute("checked", "true");	 
			}
			else {
				contextMenuRemindComplete.setAttribute("checked", "false");	 
			}
		
			if ( currentReminder.complete ) {
					contextMenuComplete.setAttribute("checked", "true");	
			}
			else {
				contextMenuComplete.setAttribute("checked", "false");	
			}	
		}
		

   }
    
}

function activateContext(event) {
	var tree = document.getElementById("reminderTree");
	var treeContextMenu = document.getElementById("treechildren-contextmenu");

	document.popupNode = tree;

	// modify context menu depending on Important reminder status
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	if ( selectedTreeItemIndex == -1 ) {
		return;
	}
	treeContextMenu.showPopup(tree, event.clientX, event.clientY, "bottomleft", "topleft");
	
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder == null ) {
		return;
	}

	var contextMenuImportant = document.getElementById("treechildren-contextmenu-important");	
	if ( currentReminder.priority != REMINDER_PRIORITY_IMPORTANT ) {
		contextMenuImportant.setAttribute("checked", "false");	
	}
	else {
		contextMenuImportant.setAttribute("checked", "true");	
	}
	
	var contextMenuRemindComplete = document.getElementById("treechildren-contextmenu-remindUntilComplete");	
	if ( currentReminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE) {
		contextMenuRemindComplete.setAttribute("checked", "true");	 
	}
	else {
		contextMenuRemindComplete.setAttribute("checked", "false");	 
	}

	var contextMenuComplete = document.getElementById("treechildren-contextmenu-markAsComplete");	
	if ( currentReminder.complete ) {
			contextMenuComplete.setAttribute("checked", "true");	
	}
	else {
		contextMenuComplete.setAttribute("checked", "false");	
	}
	
}

function activateTodoContext(event) {
	var tree = document.getElementById("todoTree");
	var treeContextMenu = document.getElementById("todo-treechildren-contextmenu");
	document.popupNode = tree;
	
	// modify context menu depending on Important reminder status
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var treeChildren = document.getElementById("todoTreechildren");
	if ( treeChildren == null || selectedTreeItemIndex == -1 || treeChildren.childNodes.length == 0 ) {
		return;
	}
	treeContextMenu.showPopup(tree, event.clientX, event.clientY, "bottomleft", "topleft");
	
	var currentTodo = getTodoForSelectedItem( );
	if ( currentTodo == null ) {
		return;
	}
	
	var contextMenuImportant = document.getElementById("treechildren-contextmenu-important2");	
	if ( currentTodo.priority != REMINDER_PRIORITY_IMPORTANT ) {
		contextMenuImportant.setAttribute("checked", "false");	
	}
	else {
		contextMenuImportant.setAttribute("checked", "true");	
	}	


	var contextMenuShowInTooltip = document.getElementById("treechildren-contextmenu-showInTooltip");	
	if ( currentTodo.showInTooltip ) {
		contextMenuShowInTooltip.setAttribute("checked", "true");	
	}
	else {
		contextMenuShowInTooltip.setAttribute("checked", "false");	
	}

	// disable moveUp/moveDown if that option isn't available
	var moveUpMenu = document.getElementById("treechildren-contextmenu-moveUp");	
	if ( selectedTreeItemIndex == 0 ) {
		moveUpMenu.setAttribute( "disabled", true );
	}
	else {
		moveUpMenu.setAttribute( "disabled", false );
	}
	
	var moveDownMenu = document.getElementById("treechildren-contextmenu-moveDown");	
	if ( selectedTreeItemIndex == (treeChildren.childNodes.length - 1) ) {
		moveDownMenu.setAttribute( "disabled", true );
	}
	else {
		moveDownMenu.setAttribute( "disabled", false );
	}	
}


function processKeyPressedOnReminderTree(event) {
	if (event.keyCode == 46)
		userDeleteReminder();
}
function processKeyPressedOnTodoTree(event) {
	if (event.keyCode == 46)
		userDeleteTodo();
}



function editReminder() {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	var treeChildren = document.getElementById("treechildren");
	 
	if ( selectedTreeItemIndex == -1 ) {
		return;
	}
	
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
	if (  selectedTreeItem == null ) {
		return;
	}

	var currentReminder = getReminderForSelectedItem();
	var originalReminder = reminderFox_cloneReminderFoxEvent(currentReminder);

	var newOptions = { reminder: currentReminder, editing:  true,  addReminder: false };
	window.openDialog("chrome://reminderfox/content/reminderOptionsDialog.xul",
			"reminderOptionsDialog", "chrome,resizable,modal", newOptions);

	if ( newOptions.addReminder ) {
		if ( originalReminder.date.getFullYear() != currentReminder.date.getFullYear() ||
			originalReminder.date.getMonth() != currentReminder.date.getMonth() ||
			originalReminder.date.getDate() != currentReminder.date.getDate() ) {
				// if the date has changed, treat as a new reminder.  This is because 
				// We want to re-add in the proper sorted order into the list of reminders
				
				removeListItemsForReminder(originalReminder);
				// remove from model list
				var reminders = reminderFox_getReminderEvents();	
				for( var i = 0; i < reminders.length; i++) {
					if ( reminders[i].id == originalReminder.id ) {
						reminderFox_removeElement(reminders, i);
						break;
					}
				}
	
				// add reminder in sorted order...
				reminders = reminderFox_getReminderEvents();					
				var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, currentReminder, false );
				reminderFox_insertIntoArray( reminders, currentReminder, sortedIndex );
				createListItem(currentReminder);			
			}
			// if the recurrence has changed, then we want to update the list as the dates may have 
			// changed
			else 	if ( originalReminder.recurrence != currentReminder.recurrence ) {
				removeListItemsForReminder(originalReminder);
				createListItem(currentReminder);			
			}
		
			var currentDate = oeDatePicker.gSelectedDate;
			if ( currentDate == null ) {
				currentDate = new Date();
			}	
			var reminder = reminderFox_processReminderDescription(currentReminder,  currentDate.getFullYear());		
			var modified = updateReminderInList( reminder );

			refreshCalendar();
			modifiedReminders();
		}
}

function userDeleteReminder() {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	var treeChildren = document.getElementById("treechildren");
	if ( selectedTreeItemIndex < 0 || selectedTreeItemIndex >= treeChildren.childNodes.length ) {
		return;
	}
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
	var descLabel = selectedTreeItem.childNodes[0].childNodes[1].getAttribute("label");
	
	var nsIPromptService = Components.interfaces.nsIPromptService;
	var nsPrompt_CONTRACTID = "@mozilla.org/embedcomp/prompt-service;1";
	var gPromptService = Components.classes[nsPrompt_CONTRACTID].getService(nsIPromptService);
	if (gPromptService.confirm(window,
		g_reminderFoxBundle.getString("rf.add.deleteReminder.title"),
		g_reminderFoxBundle.getString("rf.add.deleteReminder.description") + "\n  " + dateLabel + ": " + descLabel   )) {
     	removeReminder();
     	
		refreshCalendar();
		
		modifiedReminders();
     }
}

function userMoveReminderToTodo() {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	var treeChildren = document.getElementById("treechildren");
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
	var descLabel = selectedTreeItem.childNodes[0].childNodes[1].getAttribute("label");
	
	var nsIPromptService = Components.interfaces.nsIPromptService;
	var nsPrompt_CONTRACTID = "@mozilla.org/embedcomp/prompt-service;1";
	var gPromptService = Components.classes[nsPrompt_CONTRACTID].getService(nsIPromptService);
	if (gPromptService.confirm(window,
			g_reminderFoxBundle.getString("rf.add.moveToTodo.title"),
			g_reminderFoxBundle.getString("rf.add.moveToTodo.description") + "\n  " + descLabel   )) {

			var currentReminder = getReminderForSelectedItem( );
			var newTodo = new ReminderFoxTodo( currentReminder.id, currentReminder.summary );
			if ( currentReminder.priority ==  REMINDER_PRIORITY_IMPORTANT ) {
				newTodo.priority = REMINDER_PRIORITY_IMPORTANT;
			}
			
			// remove from reminders
			removeReminder();
			
			// add todo in sorted order...
			var todos = reminderFox_getReminderTodos();			
			var sortedIndex = reminderFox_getSortedIndexOfNewTodo(todos, newTodo );
			reminderFox_insertIntoArray( todos, newTodo, sortedIndex );
		
			createTodoListItem(newTodo, true);
	
	    	refreshCalendar();
	    
    		modifiedReminders();	    	
  	}
}

function userDeleteTodo() {
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	if ( selectedTreeItemIndex < 0  ) {
		return;
	}	
	var treeChildren = document.getElementById("todoTreechildren");
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var descLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
	
	var nsIPromptService = Components.interfaces.nsIPromptService;
	var nsPrompt_CONTRACTID = "@mozilla.org/embedcomp/prompt-service;1";
	var gPromptService = Components.classes[nsPrompt_CONTRACTID].getService(nsIPromptService);
	if (gPromptService.confirm(window,
			g_reminderFoxBundle.getString("rf.add.deleteToDo.title"),
			g_reminderFoxBundle.getString("rf.add.deleteToDo.description") + "\n  " + descLabel   )) {

     	removeTodo();
     	
  		modifiedReminders();
     }
}


function moveTodoUp() {
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var currentTodo = getTodoForSelectedItem( );

	var todos = reminderFox_getReminderTodos();
	var i;
	var found = false;
	for (  i = 0; i < todos.length; i++ ) {
		if ( todos[i].id == currentTodo.id ) {
			found = true;
			break;
		}
	}
	
	if ( found && i > 0 ) { 
		var newIndex = i - 1;  // insert before old position
		
		var newTodo =	reminderFox_cloneReminderFoxTodo( currentTodo );
		removeTodo();
		
		reminderFox_insertIntoArray( todos, newTodo, newIndex );
	
		var newListIndex = selectedTreeItemIndex - 1;
		createTodoListItemAtIndex(newTodo,newListIndex );
		
		modifiedReminders();
	}
}



function moveTodoDown() {	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var currentTodo = getTodoForSelectedItem( );

	var todos = reminderFox_getReminderTodos();
	var i;
	var found = false;
	for (  i = 0; i < todos.length; i++ ) {
		if ( todos[i].id == currentTodo.id ) {
			found = true;
			break;
		}
	}
	
	if ( found ) { 
		var newIndex = i + 1;  // insert after old position
		
		var newTodo =	reminderFox_cloneReminderFoxTodo( currentTodo );
		removeTodo();
		
		reminderFox_insertIntoArray( todos, newTodo, newIndex );
	
		var newListIndex = selectedTreeItemIndex + 1;
		createTodoListItemAtIndex(newTodo,newListIndex );
		
		modifiedReminders();
	}
}


function toggleTodoImportantFlag() {
	var currentTodo = getTodoForSelectedItem( );
	if ( currentTodo.priority == REMINDER_PRIORITY_NORMAL) { 
		currentTodo.priority = REMINDER_PRIORITY_IMPORTANT;
	}
	else {
		currentTodo.priority = REMINDER_PRIORITY_NORMAL;
	}
	
	var modified = updateTodoInList( currentTodo );
	refreshCalendar();
}

function getReminderForSelectedItem() {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	if ( selectedTreeItemIndex != -1 ) {
		var treeChildren = document.getElementById("treechildren");
		var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
		var reminderRefId = selectedTreeItem.childNodes[0].getAttribute(REMINDER_ID_REF);
		return reminderFox_getRemindersById( reminderRefId );
	}
	else {
		return null;
	}
}


function getTodoForSelectedItem() {
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	if ( selectedTreeItemIndex != -1 ) {
		var treeChildren = document.getElementById("todoTreechildren");
		var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
		var todoRefId = selectedTreeItem.childNodes[0].getAttribute(REMINDER_ID_REF);
		return reminderFox_getTodosById( todoRefId );
	}
	else {
		return null;
	}
}

function toggleImportantFlag() {
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder.priority == REMINDER_PRIORITY_NORMAL) { 
		currentReminder.priority = REMINDER_PRIORITY_IMPORTANT;
	}
	else {
		currentReminder.priority = REMINDER_PRIORITY_NORMAL;
	}
	var modified = updateReminderInList( currentReminder );
	refreshCalendar();
}

function updateReminderInList( reminder) {
	var modified = true;
	var treeChildren = document.getElementById("treechildren");
	
	var treeitems = treeChildren.childNodes;
	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];		
		var row = item.childNodes[0];
		var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
		if ( reminderRefId == reminder.id ) {
			updateReminder(  reminder, item );
		}
	}

	if ( modified ) {
		modifiedReminders();	
	}
	return modified;
}

function getTreeItemForReminder( reminder ) {
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=treeitems.length - 1; i >= 0; i--) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
		if ( reminderRefId == reminder.id ) {			
			return item;
		}
	}
	return null;
}

function updateReminder( reminder, selectedTreeItem) {
	var modified = true;

	if ( selectedTreeItem == null ) {
		selectedTreeItem = getTreeItemForReminder( reminder );
	}

	var dateNode = selectedTreeItem.childNodes[0].childNodes[0];
	var descriptionNode = selectedTreeItem.childNodes[0].childNodes[1];
	
	// update description
	
	var year = oeDatePicker.gSelectedDate.getFullYear();
	if ( year == null ) {
		year = new Date().getFullYear();
	}

	reminder = reminderFox_processReminderDescription(reminder, year);
	descriptionNode.setAttribute( "label", reminder.summary );
    var timeNode = selectedTreeItem.childNodes[0].childNodes[2];			
	 // update importance
	 if ( reminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
             // mark the date and description as important (red-highlighted)
            dateNode.setAttribute("properties", "important");
            descriptionNode.setAttribute("properties", "important");
            timeNode.setAttribute("properties", "important");
         }
       else {
            dateNode.removeAttribute("properties");
            descriptionNode.removeAttribute("properties");
			timeNode.removeAttribute("properties");            
       }
       

		if ( reminder.allDayEvent ) {
			timeNode.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {
			var time = reminderFox_getAddTimeString(reminder);
			if ( time == null ) {
				timeNode.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
			}
			else {
				timeNode.setAttribute("label", time);
			}
		}       
		
		// update once
		var repeatNode = selectedTreeItem.childNodes[0].childNodes[3];		
		if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_YEARLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_YEARLY_DAY);
		}		
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_MONTHLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_MONTHLY_DAY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
			repeatNode.setAttribute("label", REPEAT_LABEL_WEEKLY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
			repeatNode.setAttribute("label", REPEAT_LABEL_WEEKLY_ALTERNATING);
		}		
		else {		
			repeatNode.setAttribute("label", REPEAT_LABEL_NONE);
		}		
			      
       // update complete
       var completeNode = selectedTreeItem.childNodes[0].childNodes[4];       
       if ( reminder.complete ) {
        	 completeNode.setAttribute("label", COMPLETED_LABEL);		
         }
 		else {
				completeNode.removeAttribute("label");
		}
		        
         // update remind until complete
         var remindUntilCompleteNode = selectedTreeItem.childNodes[0].childNodes[5];         
         if ( reminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
        	 remindUntilCompleteNode.setAttribute("label", COMPLETED_LABEL);		
         }
		else {
				remindUntilCompleteNode.removeAttribute("label");
		}         
}
  
  

  
  
  
function updateTodoInList( todo) {
	var modified = true;
	var treeChildren = document.getElementById("todoTreechildren");

	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];	
	var descriptionNode = selectedTreeItem.childNodes[0].childNodes[0];
	
	// update description
	descriptionNode.setAttribute( "label", todo.summary );
	
	 // update importance
	 if ( todo.priority == REMINDER_PRIORITY_IMPORTANT) { 
         // mark the description as important (red-highlighted)
        descriptionNode.setAttribute("properties", "important");
     }
     else {
        descriptionNode.removeAttribute("properties");
     }
   
   // update show in tooltip
   var completeNode = selectedTreeItem.childNodes[0].childNodes[1];       
   if ( todo.showInTooltip ) {
    	 completeNode.setAttribute("label", SHOW_IN_TOOLTIP_LABEL);		
     }
 	else {
		completeNode.removeAttribute("label");
	}    
		
	if ( modified ) {
		modifiedReminders();	
	}
	return modified;
		
}



function refreshCalendar() {
	calendarReminderArray = null;	
	oeDatePicker.redrawDays();
}


function toggleTodoShowInTooltip() {
	var currentTodo = getTodoForSelectedItem( );
	currentTodo.showInTooltip = !currentTodo.showInTooltip;
	var modified = updateTodoInList( currentTodo );
	modifiedReminders();
}

function toggleRemindUntilCompleted() {
	var currentReminder = getReminderForSelectedItem( );
	var cleanUpReminderInList = false;

	if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
		currentReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED;
		
	}
	else if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED ) {
		currentReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE;
	}
	else 	if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
		currentReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE;
		cleanUpReminderInList = true;
	}
		
	var modified = updateReminderInList( currentReminder );

	modifiedReminders();
	
	// if is was marked as RemindUntilCompleted and was showing in the list at a later date, we  need to remove this from the
	// UI list back to its original location
	if ( cleanUpReminderInList ) {
		removeListItemsForReminder(currentReminder);
		createListItem(currentReminder	);
	}
	
	refreshCalendar();
}


function toggleMarkAsComplete() {
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder.complete ) { 
		currentReminder.complete = false;
	}
	else {
		if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED ||
			  currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
     		toggleRemindUntilCompleted();
     		return;     		
		}
		else {
			currentReminder.complete = true;
		}
	}
	var modified = updateReminderInList( currentReminder );

	modifiedReminders();
}